Page MenuHomePhabricator

Metrics for Maniphest
Closed, DuplicatePublic

Description

How useful and complex would be to build the following metrics in Phabricator? Wikimedia uses these metrics with Bugzilla and we need to decide whether to build a Maniphest backend for Metrics Grimoire or a native solution in Phabricator.

Key metrics that we are getting from http://korma.wmflabs.org/:

  • Volume of contributors (any activity), authors, resolvers.
  • Volume of tasks created, closed, open.
  • Median age of unattended tasks (Needs triage AND Backlog AND no comments from !author).
  • Median age of open tasks by priority (excluding Needs Volunteer).
  • Lists of main contributors TBD.

All this by project, with a possibility to aggregate data of different projects (main use case: key Wikimedia software projects. See what we have currently at

PS:

With this data, what decisions will you make differently than without it?

Wikimedia is a community project and it is very useful to observe these trends:

  • Is the amount of contributors stable, growing, shrinking? Depending on the result we will focus more or less in outreach activities.
  • Is the amount of activity stable etc? More activity proves that it is worth the effort and encourages us to invest in wanted features.
  • Are we improving at responding to reports and resolving tasks? If not, let's find the block holes and the pain points and let's change something there.
  • Who are the most valuable contributors (especially volunteers)? Let's make sure we know them, they are happy, and they can join our hackathons etc.

(Original task reported at http://fab.wmflabs.org/T53)

Event Timeline

qgil created this task.Sep 5 2014, 4:07 PM
qgil updated the task description. (Show Details)
qgil raised the priority of this task from to Needs Triage.
qgil added projects: Maniphest, Facts.
qgil added a subscriber: qgil.
qgil updated the task description. (Show Details)Sep 5 2014, 4:21 PM
qgil updated the task description. (Show Details)Sep 5 2014, 4:23 PM
g-p-g added a subscriber: g-p-g.Sep 7 2014, 1:34 AM
timor added a subscriber: timor.Sep 7 2014, 6:57 PM
qgil moved this task from Backlog to Important on the Wikimedia board.Sep 9 2014, 8:39 AM

We are trying to find an standard way to do some member performance elevation and do want to use PHABRICATOR in whole development cycle including performance elevation as it can provides data. All below metrics I want to by member.

Code lines contributed (Changed or added)
Bugs (Resolved or Opened)
Tasks (Resolved)
Inline Comments (Raised or Be Raised)
Time Cost (Resolved for bug or task)

Add one more:

Reopen items

I'm going to merge this into T4171, since there's nothing specifically actionable here that isn't covered there.

Knowing the things you're after is helpful in making sure we build the right thing when we get there. However, none of these use cases seem like they will easily create a huge amount of value for most installs, so they don't do much to movtivate prioritizing T4171. In particular: contributors/activity are pretty specific to open source projects, while I think performance metrics are really hard to get right, and may be valuable in the long run but the road there will be a long one.

T4171 isn't a priority, and we don't want to pursue these things one-by-one without investing in infrastructure first (per discussion in T6069).

If you need this stuff in the short term, I'd encourage you to build on top of Phabricator rather than waiting for upstream support. T6069 and T5051 have examples of ways you can pull data out of the system. We can give you some limited amount of help in building queries and understanding schemas, but really just don't want to take on the support costs of doing metrics right now.

(Some of these queries have workarounds in the UI, as well. For example, you can search for tasks created between Jun 1 - Jul 1, and compare that number to Jul 1 - Aug 1. Although this is slow, it's also very flexible.)

@taoqiping, T4171 is the task for your request, too. You can review that task for details, but the short version is that building analytics is a large project which we do not plan to pursue in the near future. You can try building on top of Phabricator, or you can evaluate other systems which might better suit your needs. Philosophically, this project is unlikely to ever have a major focus on metrics and analytics.

benzheren removed a subscriber: benzheren.
kwk added a subscriber: kwk.Aug 5 2015, 7:40 AM